/**
 * ISC License
 *
 * Copyright (c) 2018, Aleck Greenham
 *
 * Permission to use, copy, modify, and/or distribute this software for any purpose with or without fee is hereby granted, provided that the above copyright notice and this permission notice appear in all copies.
 *
 * THE SOFTWARE IS PROVIDED "AS IS" AND THE AUTHOR DISCLAIMS ALL WARRANTIES WITH REGARD TO THIS SOFTWARE INCLUDING ALL IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS. IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY SPECIAL, DIRECT, INDIRECT, OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF CONTRACT, NEGLIGENCE OR OTHER TORTIOUS ACTION, ARISING OUT OF OR IN CONNECTION WITH THE USE OR PERFORMANCE OF THIS SOFTWARE.
 */

"use strict";function _interopDefault(e){return e&&"object"==typeof e&&"default"in e?e.default:e}Object.defineProperty(exports,"__esModule",{value:!0});var get=_interopDefault(require("lodash.get")),set=_interopDefault(require("lodash.set")),reduce=_interopDefault(require("lodash.reduce")),isPlainObject=_interopDefault(require("lodash.isplainobject")),each=_interopDefault(require("lodash.foreach")),toPath=_interopDefault(require("lodash.topath")),isString=_interopDefault(require("lodash.isstring")),deepClone=_interopDefault(require("lodash.clonedeep")),isUndefined=_interopDefault(require("lodash.isundefined")),unique=_interopDefault(require("lodash.uniq")),keys=_interopDefault(require("lodash.keys")),map=_interopDefault(require("lodash.map")),React=require("react"),React__default=_interopDefault(React),unset=_interopDefault(require("lodash.unset")),drop=_interopDefault(require("lodash.drop")),has=_interopDefault(require("lodash.has")),defaultsDeep=_interopDefault(require("lodash.defaultsdeep")),invariant=_interopDefault(require("invariant"));function emptyFunc(){}function arrayFrom(e){return e?Array.isArray(e)?e:[e]:[]}function pickDeep(e,t){return reduce(t,function(t,a){var n=get(e,a);return set(t,a,n),t},{})}function pickOutermost(e){var t=arguments.length>1&&void 0!==arguments[1]?arguments[1]:[];return isPlainObject(e)?each(e,function(e){pickOutermost(e,t)}):Array.isArray(e)?each(e,function(e){pickOutermost(e,t)}):e&&t.push(e),t}function isNumberString(e){return!isNaN(+e)}var Wildcard="*";function extendAnyTouchedAncestors(e,t){var a=toPath(t),n=touchedAncestorPathSegments(e,a);if(n){var r=isNumberString(a[n.length])?[]:{};r[Wildcard]=Wildcard,set(e,n,r)}}function touchedAncestorPathSegments(e,t){for(var a=0;a<=t.length;){var n=t.slice(0,a+1),r=get(e,n);if(isString(r))return n;a++}}function mergeValidatedValuePaths(e,t){return reduce(e,function(e,t){return t!==Wildcard&&(extendAnyTouchedAncestors(e,t),set(e,t,t)),e},deepClone(t))}var classCallCheck=function(e,t){if(!(e instanceof t))throw new TypeError("Cannot call a class as a function")},createClass=function(){function e(e,t){for(var a=0;a<t.length;a++){var n=t[a];n.enumerable=n.enumerable||!1,n.configurable=!0,"value"in n&&(n.writable=!0),Object.defineProperty(e,n.key,n)}}return function(t,a,n){return a&&e(t.prototype,a),n&&e(t,n),t}}(),_extends=Object.assign||function(e){for(var t=1;t<arguments.length;t++){var a=arguments[t];for(var n in a)Object.prototype.hasOwnProperty.call(a,n)&&(e[n]=a[n])}return e},inherits=function(e,t){if("function"!=typeof t&&null!==t)throw new TypeError("Super expression must either be null or a function, not "+typeof t);e.prototype=Object.create(t&&t.prototype,{constructor:{value:e,enumerable:!1,writable:!0,configurable:!0}}),t&&(Object.setPrototypeOf?Object.setPrototypeOf(e,t):e.__proto__=t)},possibleConstructorReturn=function(e,t){if(!e)throw new ReferenceError("this hasn't been initialised - super() hasn't been called");return!t||"object"!=typeof t&&"function"!=typeof t?e:t},slicedToArray=function(){return function(e,t){if(Array.isArray(e))return e;if(Symbol.iterator in Object(e))return function(e,t){var a=[],n=!0,r=!1,l=void 0;try{for(var u,i=e[Symbol.iterator]();!(n=(u=i.next()).done)&&(a.push(u.value),!t||a.length!==t);n=!0);}catch(e){r=!0,l=e}finally{try{!n&&i.return&&i.return()}finally{if(r)throw l}}return a}(e,t);throw new TypeError("Invalid attempt to destructure non-iterable instance")}}(),toConsumableArray=function(e){if(Array.isArray(e)){for(var t=0,a=Array(e.length);t<e.length;t++)a[t]=e[t];return a}return Array.from(e)};function valueAlreadyTouched(e){return isString(e)||e&&e[Wildcard]}function valuesWithDefaultsAndExemptions(e){var t=e.deepMergeExemptions,a=void 0===t?{}:t,n=e.overrides,r=e.defaultValue;if(valueAlreadyTouched(a)||isUndefined(r))return n;if(isUndefined(n))return r;if(isPlainObject(n)){var l=unique([].concat(toConsumableArray(keys(r)),toConsumableArray(keys(n))));return reduce(l,function(e,t){return valueAlreadyTouched(a[t])?e[t]=n[t]:e[t]=valuesWithDefaultsAndExemptions({defaultValue:r[t],overrides:n[t],deepMergeExemptions:a[t]}),e},{})}return Array.isArray(n)?n.length>r.length?map(n,function(e,t){return valueAlreadyTouched(a[t])?e:valuesWithDefaultsAndExemptions({defaultValue:r[t],overrides:e,deepMergeExemptions:a[t]})}):map(r,function(e,t){return valueAlreadyTouched(a[t])?n[t]:valuesWithDefaultsAndExemptions({defaultValue:e,overrides:n[t],deepMergeExemptions:a[t]})}):n}var Joi=void 0,DEFAULT_STATE={errors:{},values:{},touchedValues:{},validatedValues:{},changingValues:[],validateAllValues:!1};function guessCorrectValue(e,t){var a=get(e,"target.value");return a||t}function useEventTargetValue(e){return get(e,"target.value")}function useFirstArgument(e){return e}function useSecondArgument(e,t){return t}function useThirdArgument(e,t,a){return a}var defaultChangeHandlerStrategy=guessCorrectValue,ReactJoiValidation=function(e,t){var a=t.joiSchema,n=t.joiOptions,r=t.validator,l=t.only,u=t.pseudoValues,i=void 0===u?[]:u,s=t.externalErrorsPath,o=t.changeHandlerStrategy;function d(){return isString(l)}function c(e){return d()?set({},l,e):e}function h(e){return d()?get(e,l):e}function f(e,t,a,n){return has(e,"value")?e.value:(e.strategy||o||defaultChangeHandlerStrategy)(t,a,n)}return function(t){function u(e,t){classCallCheck(this,u);var a=possibleConstructorReturn(this,(u.__proto__||Object.getPrototypeOf(u)).call(this,e,t));return a.changeHandler=a.changeHandler.bind(a),a.changesHandler=a.changesHandler.bind(a),a.changeValue=a.changeValue.bind(a),a.changeValues=a.changeValues.bind(a),a.pushHandler=a.pushHandler.bind(a),a.pushValue=a.pushValue.bind(a),a.togglePushHandler=a.togglePushHandler.bind(a),a.togglePushValue=a.togglePushValue.bind(a),a.unshiftHandler=a.unshiftHandler.bind(a),a.unshiftValue=a.unshiftValue.bind(a),a.toggleUnshiftHandler=a.toggleUnshiftHandler.bind(a),a.toggleUnshiftValue=a.toggleUnshiftValue.bind(a),a.pullHandler=a.pullHandler.bind(a),a.pullValue=a.pullValue.bind(a),a.validateHandler=a.validateHandler.bind(a),a.validate=a.validate.bind(a),a.validateAll=a.validateAll.bind(a),a.validateAllHandler=a.validateAllHandler.bind(a),a.clearValidation=a.clearValidation.bind(a),a.clearValidationState=a.clearValidationState.bind(a),a.clearValidationAndResetValues=a.clearValidationAndResetValues.bind(a),a.clearTouchedValues=a.clearTouchedValues.bind(a),a.state=_extends({},DEFAULT_STATE),a}return inherits(u,t),createClass(u,[{key:"render",value:function(){var t=this.state,a=t.touchedValues,n=t.values;return React__default.createElement(e,_extends({},this.props,this._valuesWithDefaults({values:n,touchedValues:a}),{errors:this._getActiveErrors(),changeHandler:this.changeHandler,changesHandler:this.changesHandler,changeValue:this.changeValue,changeValues:this.changeValues,pushHandler:this.pushHandler,pushValue:this.pushValue,togglePushHandler:this.togglePushHandler,togglePushValue:this.togglePushValue,unshiftHandler:this.unshiftHandler,unshiftValue:this.unshiftValue,toggleUnshiftHandler:this.toggleUnshiftHandler,toggleUnshiftValue:this.toggleUnshiftValue,pullHandler:this.pullHandler,pullValue:this.pullValue,validateHandler:this.validateHandler,validate:this.validate,validateAllHandler:this.validateAllHandler,validateAll:this.validateAll,clearValidationState:this.clearValidationState,clearValidation:this.clearValidation,clearValidationAndResetValues:this.clearValidationAndResetValues,clearValidationTouchedValues:this.clearTouchedValues}))}},{key:"pushHandler",value:function(e){var t=this,a=arguments.length>1&&void 0!==arguments[1]?arguments[1]:{};return function(n,r,l){t.pushValue(e,f(a,n,r,l),a)}}},{key:"pushValue",value:function(e,t){var a=arguments.length>2&&void 0!==arguments[2]?arguments[2]:{};this._addValue("end",e,t,a)}},{key:"togglePushHandler",value:function(e){var t=this,a=arguments.length>1&&void 0!==arguments[1]?arguments[1]:{};return function(n,r,l){t.togglePushValue(e,f(a,n,r,l),a)}}},{key:"togglePushValue",value:function(e,t){var a=arguments.length>2&&void 0!==arguments[2]?arguments[2]:{};-1===(this._getCurrentValue(e)||[]).indexOf(t)?this._addValue("end",e,t,_extends({},a,{allowDuplicates:!1})):this.pullValue(e,t,_extends({},a,{removeAllInstances:!0}))}},{key:"unshiftHandler",value:function(e){var t=this,a=arguments.length>1&&void 0!==arguments[1]?arguments[1]:{};return function(n,r,l){t.unshiftValue(e,f(a,n,r,l),a)}}},{key:"unshiftValue",value:function(e,t){var a=arguments.length>2&&void 0!==arguments[2]?arguments[2]:{};this._addValue("start",e,t,a)}},{key:"toggleUnshiftHandler",value:function(e){var t=this,a=arguments.length>1&&void 0!==arguments[1]?arguments[1]:{};return function(n,r,l){t.toggleUnshiftValue(e,f(a,n,r,l),a)}}},{key:"toggleUnshiftValue",value:function(e,t){var a=arguments.length>2&&void 0!==arguments[2]?arguments[2]:{};-1===(this._getCurrentValue(e)||[]).indexOf(t)?this._addValue("start",e,t,_extends({},a,{allowDuplicates:!1})):this.pullValue(e,t,_extends({},a,{removeAllInstances:!0}))}},{key:"pullHandler",value:function(e){var t=this,a=arguments.length>1&&void 0!==arguments[1]?arguments[1]:{};return function(n,r,l){t.pullValue(e,f(a,n,r,l),a)}}},{key:"pullValue",value:function(e,t){var a=arguments.length>2&&void 0!==arguments[2]?arguments[2]:{},n=this._getCurrentValue(e)||[],r=function(){if(a.removeAllInstances)return n.reduce(function(e,a){return a!==t&&e.push(a),e},[]);invariant(!has(a,"index")||"number"==typeof a.index,"pullValue's options.index must be a number; Received "+a.index+" instead");var e=has(a,"index")?a.index:n.indexOf(t);return-1===e?n:[].concat(toConsumableArray(n.slice(0,e)),toConsumableArray(n.slice(e+1)))}();this.changeValue(e,r,a)}},{key:"changeHandler",value:function(e){var t=this,a=arguments.length>1&&void 0!==arguments[1]?arguments[1]:{};return function(n,r,l){t.changeValue(e,f(a,n,r,l),a)}}},{key:"changeValue",value:function(e,t){var a=arguments.length>2&&void 0!==arguments[2]?arguments[2]:{};invariant(!Array.isArray(e),"Value path passed to changeValue was an array. If you want to change multiple values at once, use `changeValues` (pluralized) instead."),this.changeValues([[e,t]],a)}},{key:"changesHandler",value:function(e){var t=this,a=arguments.length>1&&void 0!==arguments[1]?arguments[1]:{};return function(){t.changeValues(e,a)}}},{key:"changeValues",value:function(e){var t=arguments.length>1&&void 0!==arguments[1]?arguments[1]:{},a=t.validate,n=void 0!==a&&a,r=t.callback,l=void 0===r?emptyFunc:r;if(invariant(Array.isArray(e),"Changes must be an array of path-value pairs"),n){var u=!0===n?map(e,function(e){return slicedToArray(e,1)[0]}):n,i=this._newState({validatePaths:u,changes:e});this._validate(i,l)}else{var s=this._newState({changes:e});this.setState(s)}}},{key:"validateAllHandler",value:function(){var e=this,t=arguments.length>0&&void 0!==arguments[0]?arguments[0]:emptyFunc;return function(){e.validateAll(t)}}},{key:"validateAll",value:function(e){this._validate(_extends({},this.state,{validateAllValues:!0}),e)}},{key:"validateHandler",value:function(e){var t=this,a=arguments.length>1&&void 0!==arguments[1]?arguments[1]:emptyFunc();return function(){t.validate(e,a)}}},{key:"validate",value:function(e){var t=arguments.length>1&&void 0!==arguments[1]?arguments[1]:emptyFunc;this._validate(this._newState({validatePaths:e}),t)}},{key:"clearValidationState",value:function(e){console.warn("Deprecation Warning: clearValidationState is deprecated. Please use clearValidationAndResetValues() instead."),this.clearValidationAndResetValues(e)}},{key:"clearValidationAndResetValues",value:function(e){if(e){var t=this.state,a=t.touchedValues,n=t.validatedValues,r=t.values,l=arrayFrom(e),u=deepClone(a),i=deepClone(n),s=deepClone(r);each(l,function(e){unset(u,e),unset(i,e),unset(s,e)}),this.setState({touchedValues:u,validatedValues:i,values:s})}else this.setState(_extends({},DEFAULT_STATE))}},{key:"clearValidation",value:function(e){if(e){var t=this.state.validatedValues,a=deepClone(t),n=arrayFrom(e);each(n,function(e){unset(a,e)}),this.setState({validatedValues:a,validateAllValues:!1})}else this.setState({validatedValues:deepClone(DEFAULT_STATE.validatedValues),validateAllValues:!1})}},{key:"clearTouchedValues",value:function(){this.setState({touchedValues:{},validateAllValues:!1})}},{key:"_addValue",value:function(e,t,a,n){var r=this._getCurrentValue(t)||[],l=!1===n.allowDuplicates&&-1!==r.indexOf(a)?r:"start"===e?[a].concat(toConsumableArray(r)):[].concat(toConsumableArray(r),[a]);this.changeValue(t,l,n)}},{key:"_newState",value:function(e){var t=e.validatePaths,a=e.changes,n=this.state,r=n.validatedValues,l=n.touchedValues,u=n.values,i=deepClone(u),s=deepClone(l),o=[];a&&each(a,function(e){var t=slicedToArray(e,2),a=t[0],n=t[1];set(i,a,n),set(s,a,a),o.push(a)});var d=t?mergeValidatedValuePaths(arrayFrom(t),r):r;return _extends({},this.state,{values:i,touchedValues:s,validatedValues:d,changingValues:o})}},{key:"_omitDeep",value:function(e,t){var a=this;return t?isPlainObject(e)?reduce(e,function(e,n,r){return isString(t[r])||(e[r]=a._omitDeep(n,t[r])),e},{}):Array.isArray(e)?reduce(e,function(e,n,r){return isString(t[r])||e.push(a._omitDeep(n,t[r])),e},[]):e:e}},{key:"_getActiveErrors",value:function(){var e=this.state,t=e.errors,a=e.validateAllValues,n=e.touchedValues,r=e.validatedValues,l=get(this.props,s||"errors",{}),u=this._omitDeep(l,n);return a?defaultsDeep({},t,u):defaultsDeep(function(e,t){var a=pickOutermost(t),n=[].concat(toConsumableArray(a),toConsumableArray(arrayFrom(i)));return reduce(n,function(t,a){if(!a.endsWith(Wildcard)){var n=get(e,a);n&&set(t,a,n)}return t},{})}(t,r),u)}},{key:"_valuesWithDefaults",value:function(t){var a=this,n=t.values,r=t.touchedValues;if(l){var u=arrayFrom(l),i=reduce(u,function(e,t){var n=t.split(/[.[]/),r=n.length>1?n[0]:t,l=get(a.props,r);return set(e,r,l),e},{}),s=pickDeep(e.defaultProps,u);return valuesWithDefaultsAndExemptions({defaultValue:defaultsDeep({},i,s),overrides:c(n),deepMergeExemptions:c(r)})}return valuesWithDefaultsAndExemptions({defaultValue:defaultsDeep({},this.props,e.defaultProps),overrides:c(n),deepMergeExemptions:c(r)})}},{key:"_getCurrentValue",value:function(e){return get(h(this._valuesWithDefaults(this.state)),e)}},{key:"_validate",value:function(e,t){var l=this,u=this._afterValidationHandler(e,t),i=h(this._valuesWithDefaults(e)),s=_extends({},e,{valuesWithDefaults:i,touchedValues:pickOutermost(e.touchedValues),validatedValues:pickOutermost(e.validatedValues),props:_extends({},this.props)});a?Joi.validate(i,a,_extends({abortEarly:!1},n),function(e){var t=e&&e.details||[],a=reduce(t,function(e,t){var a=t.message,n=t.path,r=a.replace(/^".+" /,"");return set(e,n,r),e},{});l._callValidatorIfDefined(arrayFrom(r),_extends({},s,{errors:a}),u)}):this._callValidatorIfDefined(arrayFrom(r),_extends({},s,{errors:{}}),u)}},{key:"_callValidatorIfDefined",value:function(e,t,a){var n=this;if(e.length>0){var r=e.length>1?function(r){var l=r.values,u=r.errors;n._callValidatorIfDefined(drop(e),_extends({},t,{values:l,errors:u}),a)}:a;e[0](t,r)}else{var l=t.values,u=t.errors;a({values:l,errors:u})}}},{key:"_afterValidationHandler",value:function(e,t){var a=this;return function(n){var r=n.errors,l=n.values,u=_extends({},e,{errors:r,values:l});a.setState(u,t)}}}]),u}(React.Component)};ReactJoiValidation.setJoi=function(e){Joi=e},ReactJoiValidation.setChangeHandlerStrategy=function(e){defaultChangeHandlerStrategy=e},exports.guessCorrectValue=guessCorrectValue,exports.useEventTargetValue=useEventTargetValue,exports.useFirstArgument=useFirstArgument,exports.useSecondArgument=useSecondArgument,exports.useThirdArgument=useThirdArgument,exports.default=ReactJoiValidation;
